module Picatrix
  # eats dots :)
  # and gives you back nodes and edges
  class Pacman
    attr_accessor :nodes, :edges

    def initialize(file_name)
      hash = TransformToHash.new.apply(
        DigraphParser.new.parse(
          File.read(file_name)
        )
      ).flat_map(&:entries).
      group_by(&:first).
      map {|k,v| Hash[k, v.map(&:last)]}.
      reduce({}, :merge)

      @nodes = hash[:node].reduce({}, :merge)
      @edges = hash[:edge]
    end

    def graph_hash
      {
        node: nodes,
        edge: edges
      }
    end
  end
end
