module Picatrix
  class LinkRelationIndex
    attr_accessor :as_hash
    def initialize(edges)
      @as_hash = {
        link_relations: edges.flat_map do |e|
          source = e.first.at(0)
          link_relation = e.first.at(1)[:link_relation]

          {
            link_relation.to_sym => "#{source} -(#{e.first.at(1)[:method].upcase})-> #{e.first.at(1)[:target]}"
          }
        end.inject(Hash.new([])) do |h, a|
          h[a.keys.first] += [a.values].flatten; h
        end
      }

      @controls = {
        "@controls": {
          up: up_href,
          self: self_href
        }
      }
    end
    def masoned
      @controls.merge!(@as_hash)
    end
    private
    def up_href
      "http://localhost:9292/"
    end
    def self_href
      "http://localhost:9292/rels"
    end
  end
end
